/*
 *
 *  ߥˡåϥɥ
 *
 *  Copyright 1994-1997 By A.Takuma
 *
 *  System      : Mini Message Handler
 *  Sub system  : Message path command
 *  File        : mhpath.c
 *  Version     : 2.19
 *  First Edit  : 1994-06/18
 *  Last  Edit  : 1997-12/15
 *  Author      :  
 *
 */

#include	"compat.h"
#include	"mmh.h"

char	mh_path[PATH_BUFF];		/* ᡼ѥ		*/
struct option	option[] = {		/* ץ		*/
  {"help",		0},
};
static char		mhpath_opt[SMALL_BUFF];
static struct cpy_hdr	mhpath_option[] = {
  {MH_PATH_FIELD,	mh_path,	sizeof(mh_path)},
  {"mhpathopt:",	mhpath_opt,	sizeof(mhpath_opt)},
};

/*
 * ᥤؿ
 */

int	main(argc, argv)
     int	argc;
     char	*argv[];
{
  int		status;
  int		current;
  int		i, j;
  int		t_flag = 0;
  char		*ptr, *ptr2;

  ptr = separater(argv[0]);
  if (ptr != (char*)NULL) {
    strcpy(prog_name, ptr + 1);
  } else {
    strcpy(prog_name, argv[0]);
  }

  /*
   * ե졼
   */

  if (get_environ(mhpath_option, sizeof(mhpath_option) / sizeof(struct cpy_hdr))) {
    print_fatal("Configuration error.");
    exit(1);
  }

  /*
   * åβ
   */

  ptr2 = mhpath_opt;
  for (i = 0; i < argc; i++) {
    if (i) {
      ptr = argv[i];
    } else {
      ptr = get_opt_param(&ptr2);
      if (*ptr2) {
	i--;
      }
    }
    if (*ptr == '+') {
      ptr++;
      if (*ptr) {
	strcpy(target_folder, ptr);
	t_flag = 1;
      } else {
	print_fatal("Folder does not specified.");
	exit(1);
      }
    } else if ((*ptr == '-') || (*ptr == '/')) {
      ptr++;
      for (j = 0; j < (sizeof(option) / sizeof(struct option)); j++) {
	if (!strncmp(option[j].name, ptr, strlen(option[j].name))) {
	  switch (j) {
	  case 0:	/* -help	*/
	    usage(prog_name, "[+folder] [msg] [switches]",
		  option, sizeof(option) / sizeof(struct option));
	    exit(0);
	    break;
	  default:
	    break;
	  }
	  j = -1;
	  break;
	}
      }
      if (j >= 0) {
	print_fatal("Bad option.");
	exit(1);
      }
    }
  }
  get_message(target_folder);
  current = get_current(target_folder);
  for (i = 1; i < argc; i++) {
    ptr = argv[i];
    if ((*ptr != '+') && (*ptr != '-') && (*ptr != '/')) {
      if (!strcasecmp(ptr, MH_NEW_PARAM)) {
	if (message_number > 0) {
	  add_message(message_ptr[message_number - 1] + 1);
	} else {
	  add_message(1);
	}
      } else if (add_list(ptr, current)) {
	exit(1);
      }
    }
  }
  if (check_folder(target_folder)) {
    print_fatal("Folder %s does not exist.", target_folder);
    exit(1);
  }
  status = 0;
  if (!target_number) {
    if (t_flag) {
      printf("%s/%s\n", mh_path, target_folder);
    } else {
      printf("%s\n", mh_path);
    }
    exit(0);
  }
  qsort(target_ptr, target_number, sizeof(int), int_compare);
  for (i = 0; i < target_number; i++) {
    printf("%s/%s/%d\n", mh_path, target_folder, target_ptr[i]);
  }
#ifdef	notdef
  if (t_flag) {
    set_context(target_folder, folder_stack);
  }
#endif	/* notdef */
  exit(status);
}
